/*---------------------------------------------------------------------------*
  Project:  CtrBrom - library - init
  File:     crt0_scat.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom/code32.h>
#include <brom/os.h>

/*---------------------------------------------------------------------------*
  Name:         $Sub$$stupInitSections

  Description:  Initialize Sections Patch

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
asm void $Sub$$stupInitSections(void)
{
        INASM_EXTERN( __main )

        b               __main    // call __scatterload and __rt_entry
}

/*---------------------------------------------------------------------------*
  Name:         main

  Description:  BromSpMain hook for scatterload

  Arguments:    None

  Returns:      None
 *---------------------------------------------------------------------------*/
int main( void )
{
    BromSpMain();
    while (1)
    {
    }
    // never return
}

