/*---------------------------------------------------------------------------*
  Project:  TwlBrom - exclusive
  File:     main.c

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom.h>

void BromSpMain( void )
{
    osInitException();
    osInitBROM();

    osPrintf( "ARM9: start\n" );

    osInitThread();
    while ( 1 )
    {
        if ( osTryLockByte(1, (OSLockByte *)HW_CARD_LOCK_BUF, NULL) == OS_LOCK_SUCCESS )
        {
            osTPrintf( "SpinLock is succeed.\n" );
            osSleep(800);
            osUnlockByte(1, (OSLockByte *)HW_CARD_LOCK_BUF, NULL);
            osSleep(800);
        }
        else
        {
            osTPrintf( "SpinLock is failed.\n" );
            osSleep(800);
        }
    }
}

