/*---------------------------------------------------------------------------*
  Project:  CtrBrom - init - include
  File:     crt0.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_INIT_CRT0_H_
#define BROM_INIT_CRT0_H_

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SDK_ARM11
void    BromMain(void);
#else //  SDK_ARM9
void    BromSpMain(void);
#define BromMain  BromSpMain
#endif //  SDK_ARM9


#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_INIT_CRT0_H_ */
#endif
