
#include <brom.h>

/*---------------------------------------------------------------------------*
  萔`
 *---------------------------------------------------------------------------*/
#define MIN_ORDER   1   /* ԂӖȂ */
#define MAX_ORDER   14  /* ̃VXeǗł郁eʂ(2MAX_ORDER)*PAGE_SIZEoCgɂȂ */
#define PAGE_SIZE   512 /* ŏǗP(oCg) */


/*---------------------------------------------------------------------------*
  }N
 *---------------------------------------------------------------------------*/
#define CHECK(exp) ((void)0)
#define i_osAlign(x, a) (((x)+(a)-1)&~((a)-1))  /*ACg*/
#define o2num( order ) (1 << (order))           /*2order*/


/*---------------------------------------------------------------------------*
  ^`
 *---------------------------------------------------------------------------*/
typedef unsigned int uint;
typedef unsigned char byte;

/*---------------------------------------------------------------------------*
  \̒`
 *---------------------------------------------------------------------------*/
typedef struct {
  uint max_order;       /* BuddyVXeňTCY2size_orderƂĕ\ */
                        /* max_order=14Ȃ16384oCg */

  uint page_size;       /* ŏǗPʂ̃TCY */

  void *map;            /* 񕪖؃rbg}bvւ̃|C^ */
                        /* 1oCgȏォ(2max_order)*2/8 oCgȏKv */
                        /* max_order=14Ȃ4096 Byte */

  void *mem;            /* BuddyVXeǗ郁ւ̃|C^ */
                        /* (2max_order)*page_size oCgKv */
                        /* max_order=14,page_size=4Ȃ65536 Byte */
} Buddy;

/*---------------------------------------------------------------------------*
  staticϐ
 *---------------------------------------------------------------------------*/
static Buddy my_buddy;              //
static Buddy *buddy = &my_buddy;    //g
//static byte map[4096];
//static byte mem[16384 * PAGE_SIZE];


/*---------------------------------------------------------------------------*
  static֐
 *---------------------------------------------------------------------------*/
static void mapclr( void *map, uint i );
static void mapset( void *map, uint i );
static int  mapget( void *map, uint i );
//static uint map_search( void *map, uint index_order );
static uint map_alloc( void *map, uint index_order );
static void map_free( void *map, uint i );
static void *buddy_alloc( Buddy *buddy, uint order );
static void buddy_free( Buddy *buddy, uint order, void *ptr );
static BOOL buddy_init( Buddy *buddy, uint max_order, uint page_size, void *map, void *mem );

asm u32 i_clz( u32 r0);
asm uint map_search( u32 map, u32 i); //map_search̕6.7{


/*---------------------------------------------------------------------------*
  Ǘ̈̃rbg}bv𑀍삷჌x֐
 *---------------------------------------------------------------------------*/
/* map  iԖڂ̃rbg0(gp)ɂ */
static void mapclr( void *map, uint i )
{
    u32 *temp_ptr;
    u32 word_count;
    u32 bit_count;

//  osTPrintf("%s n=%d\n",__FUNCTION__,i);
    word_count = i / 32;
    bit_count =  31 - (i % 32);

    temp_ptr = (u32 *)map + word_count;
    *temp_ptr &= ~(1 << bit_count);
}

/* map  iԖڂ̃rbg1(gp)ɂ */
static void mapset( void *map, uint i )
{
    u32 *temp_ptr;
    u32 word_count;
    u32 bit_count;

//  osTPrintf("%s n=%d\n",__FUNCTION__,i);
    word_count = i / 32;
    bit_count =  31 - (i % 32);

    temp_ptr = (u32 *)map + word_count;
    *temp_ptr |= (1 << bit_count);
}

/* map  iԖڂ̃rbg擾 */
static int mapget( void *map, uint i )
{
    u32 *temp_ptr;
    u32 word_count;
    u32 bit_count;

    word_count = i / 32;
    bit_count =  31 - (i % 32);

    temp_ptr = (u32 *)map + word_count;

    if( *temp_ptr & (1 << bit_count) ) {
        return 1;
    }
    return 0;
}


/*---------------------------------------------------------------------------*
  Name:         map_search

  Description:  w̃I[_[󂫂TAmap̉Ԗڂɂ邩ԂB
                0ԂBwȊÕI[_[ׂ͒ȂB

  Arguments:    map :
                index_order : Bitmap 2  index_order ԖڂƂӖ

  Returns:
 *---------------------------------------------------------------------------*/
#if 0
static uint map_search( void *map, uint index_order )
{
    uint num, end_of_num;
    uint i;

    /*searchJnʒu߂*/
    num = ( 1 << index_order);

    /* num (rbgP)T */
    end_of_num = (num << 1) - 1;
    while( 1 ) {
        if( mapget( map, num ) ) {
            return num;
        }
        num++;
        if( num > end_of_num ) {
          break;
        }
    }
    return 0;
}
#else
#include <brom/code32.h>
asm uint map_search( u32 map, u32 index_order)
{
    mov     r2, #1
    mov     r2, r2, lsl r1      //r2:num = 1 << index_order;        ȍ~r1󂵂OK
    mov     r3, r2, lsl #1      //
    sub     r3, r3, #1          //r3:end_of_num = (num << 1) - 1;
    mov     r1, r2, lsr #5      //r1:word_count = num/32;
    mov     r1, r1, lsl #2      //r1:byte_count = word_count*4
    add     r1, r1, r0          //r1:word_adr = byte_count+ map;    ȍ~r0󂵂OK
_ms2_loop
    ldr     r12, [r1]           //r12:temp_ptr = *(u32*)(word_adr);
    and     r0, r2, #31         //I[_[Jnrbgʒuword{łȂꍇ
    mov     r12, r12, lsl r0    //\߃VtgĂ
    clz     r12, r12
    subs    r0, r12, #32        //r0:r12-32
    bne     _ms2_found          //if( r0!=0) jump;  //Wv
    add     r2, r2, #32         //num += 32;
    add     r1, r1, #4          //word_adr += 4;
    subs    r0, r3, r2          //r0:end_of_num - num
    bcc     _ms2_notfound       //{[Wv
    b       _ms2_loop           //JԂ
_ms2_found
    add     r2, r2, r12         //r2:num=num+r12
    subs    r0, r3, r2          //r0:end_of_num - num
    bcc     _ms2_notfound       //{[Wv
    mov     r0, r2
    bx      lr
_ms2_notfound
    mov     r0, #0;
    bx      lr
}
#include <brom/codereset.h>
#endif


/*---------------------------------------------------------------------------*
  Name:         map_alloc

  Description:  w̃I[_[󂫂TAȂ΂菬I[_[
                (TCY̑傫)ċAIɕB
                󂫂΂̃rbg0ɂāÄʒuԂB

  Arguments:    map :
                index_order : Bitmap 2  index_order ԖڂƂӖ

  Returns:
 *---------------------------------------------------------------------------*/
static uint map_alloc( void *map, uint index_order )
{
    uint found;
    uint i;

//  osTPrintf( "map_search:0x%x\n", index_order);
    found = map_search( (u32)map, index_order );

    if( found == 0 ) {
        if( index_order == 0 ) {
            return 0;
        }
        i = map_alloc( map, index_order - 1 );
        if( i == 0 ) {
            return 0 ;
        }
        found = i*2;
        mapset( map, i*2+1 );
    }
    mapclr( map, found );
    return found;
}

/*---------------------------------------------------------------------------*
  Name:         map_free

  Description:  map_alloc œʒuiɂ̈JB
                _󂫂AeI[_[xŉïqjB

  Arguments:    map :
                i :

  Returns:
 *---------------------------------------------------------------------------*/
static void map_free( void *map, uint i )
{
    /*(i^1)͑_\*/
    if( mapget( map, i^1)) {
        mapclr( map, i^1);
        map_free( map, i/2);
    }else {
        mapset( map, i);
    }
}



/*---------------------------------------------------------------------------*
  Name:         buddy_alloc

  Description:  蓖
                map_alloc ŗ̈mۂAۂ̃AhXZo

  Arguments:    buddy :
                order :

  Returns:
 *---------------------------------------------------------------------------*/
static void *buddy_alloc( Buddy *buddy, uint order )
{
    uint found, offset;

    if( buddy->max_order < order ) {
        return NULL;
    }

    found = map_alloc( buddy->map, buddy->max_order - order );  //I[_[0`max_orderɂȂ
    if( found == 0 ) {
        return NULL;
    }

    CHECK( (found >= o2num(buddy->max_order - order)) );

    offset = (found - o2num(buddy->max_order - order)) * o2num(order);
    return (void *)((uint)(buddy->mem) + offset * buddy->page_size);
}


/*---------------------------------------------------------------------------*
  Name:         buddy_free

  Description:  
                ۂ̃AhX map ̈ʒuZoAmap_freeŉ

  Arguments:    buddy :
                order :

  Returns:
 *---------------------------------------------------------------------------*/
static void buddy_free( Buddy *buddy, uint order, void *ptr )
{
    uint i, offset;

    CHECK( ptr >= buddy->mem );

    offset = ((uint)ptr - (uint)buddy->mem) / buddy->page_size;
    i = offset / o2num(order) + o2num(buddy->max_order - order);
    map_free( buddy->map, i );
}


/*---------------------------------------------------------------------------*
  Name:         buddy_init

  Description:  mۃVXẽRtBO[V
                q[v̑傫ŏǗTCYȂǂݒ肷

  Arguments:

  Returns:      TRUE / FALSE
 *---------------------------------------------------------------------------*/
static BOOL buddy_init( Buddy *buddy, uint max_order, uint page_size, void *map, void *mem )
{
    if ( (max_order < MIN_ORDER) && (MAX_ORDER < max_order) ) {
        return FALSE;
    }
    miCpuFill8( map, 0, o2num(max_order) * 2 / 8 ); //8ŊăoCgPʂɂ
    mapset( map, 1 );
    buddy->max_order    = max_order;
    buddy->page_size    = page_size;
    buddy->map          = map;
    buddy->mem          = mem;
    return TRUE;
}



/*API*/

/*---------------------------------------------------------------------------*
  Name:         buddy_allocator_init

  Description:  mۃVXȅ
                sizeɂẮAgȂheap̈悪傫Ȃ邱Ƃɒ

  Arguments:    none

  Returns:      none
 *---------------------------------------------------------------------------*/
BOOL buddy_allocator_init( void* heap, u32 size)
{
    u32     map;
    u32     mem;
    u32     aligned_size;
    u32     max_order;
    u32     mult_of_2;
    u32     map_size, mem_size;

    /*heapAhXƃTCYAǗ̈ƃ̈Zo*/
    map = i_osAlign( (u32)(heap), 4);
    if( (map - (u32)(heap)) >= size) {
        return( FALSE);
    }
    aligned_size    = size - (map - (u32)(heap));
    mult_of_2       = (8 * aligned_size) / (8 * PAGE_SIZE + 2);
    max_order       = 31 - i_clz( mult_of_2);
    map_size        = ((1 << max_order) * 2) / 8;
    mem             = map + map_size;
    mem_size        = ((1 << max_order) * PAGE_SIZE);

    /* Buddy *buddy, uint max_order, uint page_size, void *map, void *mem  */
    if( buddy_init( buddy, (uint)max_order, (uint)PAGE_SIZE, (void *)map, (void *)mem)) {
        osTPrintf( "buddy allocator init success!\n");
        osTPrintf( "heap address : 0x%x,   heap size : 0x%x\n", heap, size);
        osTPrintf( "map address  : 0x%x,   map size  : 0x%x\n", map, map_size);
        osTPrintf( "mem address  : 0x%x,   mem size  : 0x%x\n", mem, mem_size);
        osTPrintf( "max order    : 0x%x\n", max_order);
        return( TRUE);
    }else {
        osTPrintf( "buddy allocator init fail!\n");
        return( FALSE);
    }
}

#include <brom/code32.h>
asm u32 i_clz( u32 r0)
{
    clz r0, r0
    bx  lr
}
#include <brom/codereset.h>


/*---------------------------------------------------------------------------*
  Name:         malloc

  Description:  mہiACgwłȂj

  Arguments:    size : TCY

  Returns:      void* : AhX
 *---------------------------------------------------------------------------*/
void *osAlloc( uint size )
{
    void *ptr;
    uint order;

    /*w̃TCYɈԋ߂I[_[T*/
    for( order=0; order<=MAX_ORDER; order++) {
        if( (size + sizeof(uint)) <= (o2num(order) * PAGE_SIZE) ) {
            break;
        }
    }
    if( order > MAX_ORDER ) {
        return NULL;
    }

    ptr = buddy_alloc( buddy, order );  //order  0`MAX_ORDER
    if( ptr == NULL ) {
        return NULL;
    }

    /*
    * 蓖Ă̈̐擪 order i[A̕|C^炷
    */
    *(*(uint**)&ptr) = order;
    *(uint*)&ptr += sizeof(uint);

    return ptr;
}


/*---------------------------------------------------------------------------*
  Name:         free

  Description:  

  Arguments:    mem : AhX

  Returns:      none
 *---------------------------------------------------------------------------*/
void osFree( void *mem )
{
    void *ptr;
    uint order;

    /*order 𓾂*/
    ptr = (void *)((uint)mem - sizeof(uint));
    order = *(uint*)ptr;

    buddy_free( buddy, order, ptr );
}
