#ifndef _RANDOMLIB_H
#define _RANDOMLIB_H

#include "revolution.h"

/*
#if _IOP
#include "types.h"
#else
#include "revolution/types.h"
#endif
*/

#include "wfs_Platform.h"

void   RandomInitialise(int ij, int kl);
double RandomUniform(void);
double RandomGaussian(double mean, double stddev);
int    RandomInt(int lower, int upper);
double RandomDouble(double lower, double upper);
u32    RandomU32();

#define NUM_UNIQUE_RANDOM_SEEDS_U32 0x382C7A42
void   RandomSetSeedU32(u32 nSeed);

#endif
