#ifndef __NFS_DRNAND_H__
#define __NFS_DRNAND_H__

#include <brom.h>
#include <firm.h>

#define NFS_DEVCTL_GET_GEOMETRY    0
#define NFS_DEVCTL_FORMAT          1
#define NFS_DEVCTL_REPORT_REMOVE   2
#define NFS_DEVCTL_CHECKSTATUS     3
#define NFS_DEVCTL_WARMSTART       4
#define NFS_DEVCTL_POWER_RESTORE   5
#define NFS_DEVCTL_POWER_LOSS      6


#ifdef	__cplusplus
extern "C" {
#endif
BOOL nandNfsIo( int driveno, u32 block, void* buffer, u16 count, BOOL reading);
int nandNfsCtrl( int driveno, int opcode, void* pargs);
#ifdef	__cplusplus
}
#endif


#endif // __NFS_DRNAND_H__
