/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfskrn_Utils.h

  Copyright 2007 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfskrn_Utils.h,v $
  Revision 1.1  2008/12/03 00:11:29  kondo_masahiro
  Initial check-in.


*---------------------------------------------------------------------------*/

#ifndef wfskrn_Utils_h
#define wfskrn_Utils_h

#include "wfskrn_Defs.h"

void _qsort(void *base, size_t num, size_t size, int (*compare)(const void*, const void*) );
int CompareBlkAdrForward(const void *pA, const void *pB);
int CompareBlkAdrReverse(const void *pA, const void *pB);

#endif // wfskrn_Utils_h
