/*---------------------------------------------------------------------------*
  Project:  TwlSDK - STD - include
  File:     string.h

  Copyright 2005-2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/

#ifndef FIRM_HEAP_HEAP_H_
#define FIRM_HEAP_HEAP_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <brom/misc.h>
#include <brom/types.h>
#include <brom/mi/memory.h>

typedef int OSHeapHandle;

extern BOOL buddy_allocator_init( void* heap, u32 size);
extern void *osAlloc( unsigned int size );
extern void osFree( void *mem );

#ifdef __cplusplus
} /* extern "C" */
#endif

/* FIRM_HEAP_HEAP_H_ */
#endif
