/*---------------------------------------------------------------------------*
  Project:  CtrBrom - bootrom - init
  File:     crt0.c

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#include <brom/code32.h>
#include <brom/types.h>
#include <brom/hw/common/mmap_prom.h>

/*---------------------------------------------------------------------------*
  Name:         _start

  Description:  Start up

  Arguments:    None

  Returns:      None.
 *---------------------------------------------------------------------------*/
asm void _start( void )
{
        PRESERVE8

        EXPORT  CTR_BROM_ARM11
        EXPORT  CTR_BROM_ARM9

CTR_BROM_ARM11
        INCBIN  BROM_PADBIN_ARM11
CTR_BROM_ARM9
        INCBIN  BROM_PADBIN_ARM9
}
