/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_app.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::           $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_ARM11_MMAP_APP_H_
#define BROM_HW_ARM11_MMAP_APP_H_

#include <brom/memorymap.h>
#include <app/hw/ARM11/mmap_main.h>

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------- HW_APP
#define HW_APP                          HW_MAIN_MEM
#define HW_APP_END                      HW_APP_STACK
#define HW_APP_SIZE                     (HW_APP_END - HW_APP)


#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_ARM11_MMAP_APP_H_ */
#endif
