/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_app.h

  Copyright 2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_APP_HW_ARM9_MMAP_APP_H_
#define BROM_APP_HW_ARM9_MMAP_APP_H_

#include <brom/hw/ARM9/mmap_brom.h>
#include <app/hw/ARM9/mmap_tcm.h>

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------- APP
#define HW_APP                          HW_PRV_WRAM_SYSRV_END
#define HW_APP_END                      (HW_APP + HW_APP_SIZE)
#define HW_APP_SIZE                     (HW_PRV_WRAM_SIZE - HW_PRV_WRAM_SYSRV_SIZE)  // 擪̈̂ݗ\AX^bNDTCM


#ifdef __cplusplus
} /* extern "C" */
#endif

/* BROM_APP_HW_ARM9_MMAP_APP_H_ */
#endif
