/*---------------------------------------------------------------------------*
  Project:  CtrBrom - HW - include
  File:     mmap_prom.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_HW_COMMON_MMAP_PROM_H_
#define BROM_HW_COMMON_MMAP_PROM_H_

#include <brom/brom_defs.h>

#ifdef __cplusplus
extern "C" {
#endif

//----------------------------- PROM
#define HW_PROM                 0x00000000
#define HW_PROM_END             (HW_PROM + HW_PROM_SIZE)
#define HW_PROM_SIZE            0x00020000

#define HW_PROM_ARM11           HW_PROM
#define HW_PROM_ARM11_END       (HW_PROM_ARM9 + HW_PROM_ARM9_SIZE)
#define HW_PROM_ARM11_SIZE      0x00010000
#define HW_PROM_ARM9            HW_PROM_ARM9_END
#define HW_PROM_ARM9_END        (HW_PROM_ARM7 + HW_PROM_ARM7_SIZE)
#define HW_PROM_ARM9_SIZE       0x00010000

#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_HW_COMMON_MMAP_PROM_H_ */
#endif
