/*---------------------------------------------------------------------------*
  Project:  CtrBrom - include - HW
  File:     memorymap.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef BROM_MEMORYMAP_H_
#define BROM_MEMORYMAP_H_

#ifdef __cplusplus
extern "C" {
#endif

#include	<ctr/memorymap.h>

#ifdef	SDK_ARM11
#include	<brom/hw/ARM11/mmap_brom.h>
#include	<firm/hw/ARM11/mmap_firm.h>
#include	<brom/hw/common/mmap_shared.h>

#else  //SDK_ARM9
#include	<brom/hw/ARM9/mmap_brom.h>
#include	<firm/hw/ARM9/mmap_firm.h>
#include	<brom/hw/common/mmap_shared.h>

#endif

#ifdef __cplusplus
} /* extern "C" */
#endif
/* BROM_MEMORYMAP_H_ */
#endif
