/*---------------------------------------------------------------------------*
  File:     msc_api.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

*---------------------------------------------------------------------------*/

typedef u32 MSCError;

#define IOS_ERROR_MSC_OK                    0

#define IOS_ERROR_MSC_DEVICE_DETACH         -8001
#define IOS_ERROR_MSC_COMMAND_FAILED        -8002
#define IOS_ERROR_MSC_PHASE_ERROR           -8003
#define IOS_ERROR_MSC_INVALID_CBW_SIGNATURE -8004
#define IOS_ERROR_MSC_INVALID_CBW_TAG       -8005

#define IOS_ERROR_MSC_HASH_INCONSISTENT     -8101

#if _IOP
IOSError MscCheckCswError(HardDisc *p_hd, IOSError ie);
#endif

