/*---------------------------------------------------------------------------*
  Project:  wfs
  File:     wfs_Permission_AccessList_Type.h

  Copyright 2008 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Log: wfskrn_Permission_AccessList_Type.h,v $
  Revision 1.1  2008/09/24 07:50:34  ueno
  Added AclHdr{} to AreaHdr{} to save configuration of accesslists in a disk.



*---------------------------------------------------------------------------*/
#ifndef __WFSKRN_PERMISSION_ACCESSLIST_TYPE_H__
#define __WFSKRN_PERMISSION_ACCESSLIST_TYPE_H__

typedef struct _AclHdr
{
    WFSBlkAdr aclBlock;
    WFSBlkAdr nameBlock;
} AclHdr;

#endif // __WFSKRN_PERMISSION_ACCESSLIST_TYPE_H__
