/*---------------------------------------------------------------------------*
  Project:  CtrFirm - HW - include
  File:     mmap_axi_wram.h

  Copyright 2008-2009 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

  $Date::            $
  $Rev$
  $Author$
 *---------------------------------------------------------------------------*/
#ifndef FIRM_HW_ARM11_MMAP_FIRM_H_
#define FIRM_HW_ARM11_MMAP_FIRM_H_

#include <ctr/hw/ARM11/mmap_global.h>
#include <firm/hw/ARM11/mmap_axi_wram.h>

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------- FIRM
#define HW_FIRM                         HW_AXI_WRAM
#define HW_FIRM_END                     HW_FIRM_STACK
#define HW_FIRM_SIZE                    (HW_FIRM_END - HW_FIRM)  // 512KB - 48KB

#ifdef __cplusplus
} /* extern "C" */
#endif

/* FIRM_HW_ARM11_MMAP_FIRM_H_ */
#endif
